VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.0#0"; "MSCOMM32.OCX"
Begin VB.Form Main 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VBtext"
   ClientHeight    =   4005
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   5655
   Icon            =   "main.frx":0000
   LinkTopic       =   "Main"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4005
   ScaleWidth      =   5655
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   4200
      TabIndex        =   4
      Top             =   3120
      Width           =   1215
   End
   Begin VB.TextBox txtMessage 
      Height          =   1815
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   1080
      Width           =   5175
   End
   Begin VB.TextBox txtTo 
      Height          =   285
      Left            =   840
      TabIndex        =   1
      Top             =   240
      Width           =   1695
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2760
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      Handshaking     =   2
      InputLen        =   1
      RThreshold      =   1
      RTSEnable       =   -1  'True
      BaudRate        =   2400
   End
   Begin VB.Label Label2 
      Caption         =   "Message"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "To:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   495
   End
   Begin VB.Menu mnuExit 
      Caption         =   "E&xit"
   End
   Begin VB.Menu mnuComport 
      Caption         =   "&COM port"
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Option Base 1

Dim COMport As Integer

Dim RXstate As Byte
Const rxsIdle = 1
Const rxsGetSender = 2
Const rxsGetMessage = 3

Const DoubleQuote = """"    ' This defines a single character string consisting of one doublequote

Dim SerialRXBuf As String

Dim rxDate As Date
Dim rxTime As Date
Dim rxNumber As String
Dim rxMessage As String
Dim rxStore As String

Private Sub cmdSend_Click()

    MSComm1.Output = "AT+CMGS=" & txtTo.Text & vbCrLf
    
    MSComm1.Output = txtMessage.Text & Chr(26)  ' Chr(26) is control-Z
        
End Sub

Private Sub Form_Load()

    COMport = GetSetting("VBtext", "Port", "COMport", -1)
    
    If COMport < 1 Then     ' Our registry setting doesn't exist, get port number from Ztext
    
        COMport = Val(GetRegValue(HKEY_CURRENT_USER, "Software\GCRSoft\z-text\1.0", "Port"))

        If COMport < 1 Then ' Ztext doesn't have the setting either, ask the user
    
            SerialPort.Show vbModal

        Else
        
            SaveSetting "VBtext", "Port", "COMport", COMport
        
        End If
        
    End If
    
    If COMport > 0 Then

        MSComm1.CommPort = COMport
        MSComm1.PortOpen = True
        
        MSComm1.Output = "ATE0" & vbCrLf        ' Tell the modem not to echo back our commands
    
        RXstate = rxsIdle
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    If MSComm1.PortOpen Then
    
        MSComm1.PortOpen = False
        
    End If
    
End Sub

Private Sub mnuComport_Click()

    If MSComm1.PortOpen Then    ' Close the existing port if it is open
    
        MSComm1.PortOpen = False
        
    End If
    
    SerialPort.Show vbModal
    
    COMport = GetSetting("VBtext", "Port", "COMport", -1)
    
    If COMport > 0 Then

        MSComm1.CommPort = COMport
        MSComm1.PortOpen = True
        
        MSComm1.Output = "ATE0" & vbCrLf        ' Tell the modem not to echo back our commands
    
        RXstate = rxsIdle
        
    End If
    
End Sub

Private Sub mnuExit_Click()

    End
    
End Sub

Private Sub MSComm1_OnComm()

    Dim Temp As String
    
    Select Case MSComm1.CommEvent
    ' Handle each event or error by placing
    ' code below each case statement

    ' Errors
        Case comEventBreak   ' A Break was received.
        Case comEventFrame   ' Framing Error
        Case comEventOverrun   ' Data Lost.
        Case comEventRxOver   ' Receive buffer overflow.
        Case comEventRxParity   ' Parity Error.
        Case comEventTxFull   ' Transmit buffer full.
        Case comEventDCB   ' Unexpected error retrieving DCB]

    ' Events
        Case comEvCD   ' Change in the CD line.
        Case comEvCTS   ' Change in the CTS line.
        Case comEvDSR   ' Change in the DSR line.
        Case comEvRing   ' Change in the Ring Indicator.
        Case comEvReceive   ' Received RThreshold # of chars or more
      
            Temp = MSComm1.Input    ' InputLen must be 1 to ensure we only get one character at a time
            
            If Temp = vbCr Then      ' Do we have a complete line?
            
                HandleRX (SerialRXBuf)  ' Yes, go find out what it means
                SerialRXBuf = ""
                
            ElseIf Temp <> vbLf Then        ' Filter out linefeeds, they just get in the way!
            
                SerialRXBuf = SerialRXBuf + Temp
                
            End If
        
        Case comEvSend   ' There are SThreshold number of
                     ' characters in the transmit
                     ' buffer.
        Case comEvEOF   ' An EOF charater was found in
                     ' the input stream
    End Select

End Sub


Public Sub HandleRX(RXData As String)

    Dim Pointer As Integer
    
    Select Case RXstate
    
        Case rxsIdle
        
            If Left(RXData, 5) = "+CMT:" Then
            
                Pointer = InStr(1, RXData, ",") + 1
                rxStore = Mid(RXData, Pointer)
                MSComm1.Output = "AT+CMGR=" & rxStore & vbCrLf    ' Read the message from the modem
                
                RXstate = rxsGetSender
                
            End If
                
        Case rxsGetSender
        
            If Left(RXData, 6) = "+CMGR:" Then
            
                Pointer = InStr(1, RXData, ",") + 1 ' Find beginning of sender's number
                
                rxNumber = Mid(RXData, Pointer, InStr(Pointer, RXData, ",") - Pointer)
                
                Pointer = InStr(Pointer, RXData, DoubleQuote) + 1 ' Now find beginning of timestamp
                
                rxDate = CDate(Mid(RXData, Pointer + 6, 2) & "/" & Mid(RXData, Pointer + 3, 2) & "/" & Mid(RXData, Pointer, 2))
                rxTime = CDate(Mid(RXData, Pointer + 9, 8))
                 
                rxMessage = ""
                
                RXstate = rxsGetMessage     ' Now get the message itself
            
            End If
        
        Case rxsGetMessage
        
            If RXData = "OK" Then       ' OK on a line by itself means that we are at the end of the message
            
                RXstate = rxsIdle
            
                MSComm1.Output = "AT+CMGD=" & rxStore & vbCrLf    ' Delete the message from the modem
                
                Load Received   ' Load the form so that we can fill in the text boxes
                
                Received.txtFrom = rxNumber
                Received.txtTime = Format(rxTime, "Long Time") & " " & Format(rxDate, "Long Date")
                
                Received.txtMessage = rxMessage
                
                Received.Show vbModal
                
            Else
            
                If rxMessage <> "" Then     ' Is this after the first line of the message?
                
                    rxMessage = rxMessage + vbCrLf      ' Yes, add back the crlf that was filtered out before this function was called
                
                End If
                
                rxMessage = rxMessage + RXData
                
            End If
            
    End Select
    
End Sub
